diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index fedbd41da..77a5162ef 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -914,17 +912,17 @@ public final class RenderBlocks {
         double zMax = z + bounds.maxZ();
 
         if (this.enableAO) {
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopLeft);
-            tessellator.setColorOpaque_F(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(xMax, yMin, zMax, uMin2, vMax2);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomLeft);
-            tessellator.setColorOpaque_F(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMax);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordBottomRight);
-            tessellator.setColorOpaque_F(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(xMax, yMax, zMin, uMax2, vMin2);
-            if (LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(this.lightmapCoordTopRight);
-            tessellator.setColorOpaque_F(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
+            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMin);
         } else {
             tessellator.addVertexWithUV(xMax, yMin, zMax, uMin2, vMax2);
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
index 4978440b2..0e7bc9ce7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
@@ -50,7 +50,7 @@ public abstract class EntityCamera
         if (partialTick == 1f || this.mob.isRemoved()) {
             return this.mob.y + this.mob.getHeadHeight();
         } else {
-            if (Double.isNaN(this.hhO)) this.hhO = this.mob.getHeadHeight();
+            if (!Double.isFinite(this.hhO)) this.hhO = this.mob.getHeadHeight();
             return (this.mob.yo + (this.mob.y - this.mob.yo) * partialTick) + MathHelper.lerp(this.hhO, this.mob.getHeadHeight(), partialTick);
         }
     }
@@ -86,7 +86,7 @@ public abstract class EntityCamera
 
     @Override
     public double getFov() {
-        return this.mc.gameSettings.FoV.value;
+        return this.mc.gameSettings.FoV.get();
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java b/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
index e580aa5d3..f7d88dc6a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
+++ b/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
@@ -1,29 +1,41 @@
 package net.minecraft.client.render.culling;
 
 import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.renderer.GLRenderer;
 import org.jetbrains.annotations.NotNull;
+import org.joml.FrustumIntersection;
+import org.joml.Matrix4f;
 import org.joml.primitives.AABBdc;
 
 public class CameraFrustum {
     private final @NotNull ICamera camera;
-    private final @NotNull FrustumData frustum;
+    private static final @NotNull FrustumIntersection frustum = new FrustumIntersection();
+    private static final @NotNull Matrix4f matrix4f = new Matrix4f();
+
+    public static void recalcFrustrum() {
+        frustum.set(GLRenderer.projectionM4f().mul(GLRenderer.viewM4f(), matrix4f).mul(GLRenderer.modelM4f(), matrix4f));
+    }
+
+    public static @NotNull FrustumIntersection getFrustum() {
+        return frustum;
+    }
 
     public CameraFrustum(@NotNull ICamera camera) {
         this.camera = camera;
-        this.frustum = Frustum.getFrustum();
     }
 
-    public boolean cubeInFrustum(double x0, double y0, double z0, double x1, double y1, double z1, float partialTick) {
-        return this.frustum.cubeInFrustum(x0 - this.camera.getX(partialTick),
-            y0 - this.camera.getY(partialTick),
-            z0 - this.camera.getZ(partialTick),
-            x1 - this.camera.getX(partialTick),
-            y1 - this.camera.getY(partialTick),
-            z1 - this.camera.getZ(partialTick)
+    public boolean cubeInFrustum(@NotNull AABBdc aabb, float partialTick) {
+        return frustum.testAab(
+            (float) (aabb.minX() - this.camera.getX(partialTick)),
+            (float) (aabb.minY() - this.camera.getY(partialTick)),
+            (float) (aabb.minZ() - this.camera.getZ(partialTick)),
+            (float) (aabb.maxX() - this.camera.getX(partialTick)),
+            (float) (aabb.maxY() - this.camera.getY(partialTick)),
+            (float) (aabb.maxZ() - this.camera.getZ(partialTick))
         );
     }
 
     public boolean isVisible(@NotNull AABBdc aabb, float partialTick) {
-        return cubeInFrustum(aabb.minX(), aabb.minY(), aabb.minZ(), aabb.maxX(), aabb.maxY(), aabb.maxZ(), partialTick);
+        return cubeInFrustum(aabb, partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 0d39a788f..b0922931b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -1,20 +1,24 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
-import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.ImageParser;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
@@ -29,7 +33,7 @@ import java.util.Map;
 public abstract class EntityRenderer<T extends Entity> {
     public static boolean renderShadows = true;
     private final @NotNull Map<@NotNull String, @NotNull StaticEntityModel> modelMap = new HashMap<>();
-    protected EntityRenderDispatcher renderDispatcher = null;
+    protected EntityRendererDispatcher renderDispatcher = null;
     protected Class<? extends T> appliedClass = null;
 
     private float shadowSize;
@@ -48,10 +52,10 @@ public abstract class EntityRenderer<T extends Entity> {
         return this.shadowSize;
     }
 
-    public abstract void render(@NotNull Tessellator tessellator, @NotNull T entity, double x, double y, double z,
+    public abstract void render(@NotNull TessellatorGeneral tessellator, @NotNull T entity, double x, double y, double z,
                                 float yaw, float partialTick);
 
-    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public void renderPreview(@NotNull final TessellatorGeneral tessellator, @NotNull final T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         render(tessellator, entity, x, y, z, yaw, partialTick);
     }
 
@@ -69,7 +73,7 @@ public abstract class EntityRenderer<T extends Entity> {
         if (model != null) {
             return model;
         }
-        EntityDispatcher.EntityDispatcherEntry entry = EntityDispatcher.getInstance().entryForClass(this.appliedClass);
+        EntityDispatcher.EntityDispatcherEntry<? extends T> entry = EntityDispatcher.getInstance().entryForClass(this.appliedClass);
         final NamespaceID id = entry != null ? entry.namespaceID : null;
         if (id != null) {
             model = EntityGeometryMojangData.Cache.getModelForEntity(id, localId);
@@ -88,26 +92,24 @@ public abstract class EntityRenderer<T extends Entity> {
     public void onWorldChanged(final @NotNull World world) {
     }
 
-    private void renderFire(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float partialTick) {
-        GL11.glDisable(GL11.GL_LIGHTING);
+    private void renderFire(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float partialTick) {
+        GLRenderer.globalSetLightEnabled(false);
         final IconCoordinate texture = TextureRegistry.getTexture("minecraft:block/fire");
         texture.parentAtlas.bind();
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float) x, (float) y, (float) z);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
         final float f9 = entity.bbWidth * 1.4F;
-        GL11.glScalef(f9, f9, f9);
+        GLRenderer.modelM4f().scale(f9, f9, f9);
         float f10 = 0.5F;
         final float f11 = 0.0F;
         float f12 = entity.bbHeight;
         float f13 = (float) (entity.y - entity.bb.minY);
-        GL11.glRotatef(-this.renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
-        GL11.glTranslatef(0.0F, 0.0F, -0.3F + (float) (int) f12 * 0.02F);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        if (LightmapHelper.isLightmapEnabled()) {
-            int lightmapCoord = entity.getLightmap(partialTick);
-            lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
-            LightmapHelper.setLightmapCoord(lightmapCoord);
-        }
+        GLRenderer.modelM4f().rotateY(Math.toRadians(-this.renderDispatcher.viewLerpYaw));
+        GLRenderer.modelM4f().translate(0.0F, 0.0F, -0.3F + (float) (int) f12 * 0.02F);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        int lightmapCoord = entity.getLightmap(partialTick);
+        lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
+        GLRenderer.setLightmapCoord1i(lightmapCoord);
         float f14 = 0.0F;
         int l = 0;
         tessellator.startDrawingQuads();
@@ -132,18 +134,18 @@ public abstract class EntityRenderer<T extends Entity> {
             l++;
         }
         tessellator.draw();
-        GL11.glPopMatrix();
-        GL11.glEnable(GL11.GL_LIGHTING);
+        GLRenderer.popFrame();
+        GLRenderer.globalSetLightEnabled(true);
     }
 
-    private void renderShadow(final @NotNull Tessellator tessellator, @NotNull final T entity, final double posX, final double posY, final double posZ,
+    private void renderShadow(final @NotNull TessellatorGeneral tessellator, @NotNull final T entity, final double posX, final double posY, final double posZ,
                               final float opacity, final float partialTick) {
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         final TextureManager textureManager = this.renderDispatcher.textureManager;
         textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/shadow.png"));
         final World world = entity.world;
-        GL11.glDepthMask(false);
+        GLRenderer.setDepthMask(false);
         final double lerpX = entity.xo + (entity.x - entity.xo) * (double) partialTick;
         final double lerpY = entity.yo + (entity.y - entity.yo) * (double) partialTick + (double) entity.getShadowHeightOffs();
         final double lerpZ = entity.zo + (entity.z - entity.zo) * (double) partialTick;
@@ -174,12 +176,12 @@ public abstract class EntityRenderer<T extends Entity> {
         }
 
         tessellator.draw();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDepthMask(true);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.setDepthMask(true);
     }
 
-    private void renderShadowOnBlock(final @NotNull Tessellator tessellator, final @NotNull T entity, final @NotNull Block<?> block, final double d, final double d1, final double d2,
+    private void renderShadowOnBlock(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final @NotNull Block<?> block, final double d, final double d1, final double d2,
                                      final int x, final int y, final int z, final float opacity, final float size, final double xo,
                                      final double yo, final double zo) {
         if (!block.isCubeShaped()) {
@@ -194,7 +196,7 @@ public abstract class EntityRenderer<T extends Entity> {
         if (alpha > 1.0D) {
             alpha = 1.0D;
         }
-        tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, (float) alpha);
+        tessellator.setColor4f(1.0F, 1.0F, 1.0F, (float) alpha);
         final AABBdc aabb = block.getCollisionBoundingBoxFromPool(entity.world, x, y, z);
         if (aabb == null) {
             return;
@@ -214,9 +216,10 @@ public abstract class EntityRenderer<T extends Entity> {
         tessellator.addVertexWithUV(xMax, yMin, zMin, f3, f4);
     }
 
-    public static void renderOffsetAABB(final @NotNull Tessellator tessellator, final @NotNull AABBdc aabb, final double x, final double y, final double z) {
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+    public static void renderOffsetAABB(final @NotNull TessellatorGeneral tessellator, final @NotNull AABBdc aabb, final double x, final double y, final double z) {
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         tessellator.startDrawingQuads();
         tessellator.setTranslation(x, y, z);
         tessellator.setNormal(0.0F, 0.0F, -1F);
@@ -251,11 +254,11 @@ public abstract class EntityRenderer<T extends Entity> {
         tessellator.addVertex(aabb.maxX(), aabb.minY(), aabb.maxZ());
         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
         tessellator.draw();
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GLRenderer.popFrame();
     }
 
     public static void renderFlatAABB(final @NotNull AABBdc aabb) {
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertex(aabb.minX(), aabb.maxY(), aabb.minZ());
         tessellator.addVertex(aabb.maxX(), aabb.maxY(), aabb.minZ());
@@ -289,12 +292,12 @@ public abstract class EntityRenderer<T extends Entity> {
         tessellator.draw();
     }
 
-    public void init(@NotNull final Class<? extends T> appliedClass, final @NotNull EntityRenderDispatcher dispatcher) {
+    public void init(@NotNull final Class<? extends T> appliedClass, final @NotNull EntityRendererDispatcher dispatcher) {
         this.renderDispatcher = dispatcher;
         this.appliedClass = appliedClass;
     }
 
-    public void postRender(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public void postRender(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         if (renderShadows && this.renderDispatcher.settings.fancyGraphics.value == 1 && getShadowSize(entity) > 0.0F) {
             final double distance = this.renderDispatcher.distanceToLerpSquared(entity.x, entity.y, entity.z);
             final float opacity = (float) ((1.0D - distance / 256D) * (double) this.shadowOpacity);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
index 7998bd015..bf99e95e6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
@@ -1,48 +1,47 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 
-public class EntityRendererArrow extends EntityRenderer<ProjectileArrow>
-{
+public class EntityRendererArrow extends EntityRenderer<ProjectileArrow> {
     @Override
-    public void render(@NotNull Tessellator tessellator, @NotNull ProjectileArrow arrow, double x, double y, double z,
+    public void render(@NotNull TessellatorGeneral tessellator, @NotNull ProjectileArrow arrow, double x, double y, double z,
                        float yaw, float partialTick) {
         bindTexture("/assets/minecraft/textures/entity/arrows.png");
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float)x, (float)y, (float)z);
-        GL11.glRotatef((arrow.yRotO + (arrow.yRot - arrow.yRotO) * partialTick) - 90F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(arrow.xRotO + (arrow.xRot - arrow.xRotO) * partialTick, 0.0F, 0.0F, 1.0F);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+
+        GLRenderer.modelM4f().rotateY(Math.toRadians(Math.lerp(arrow.yRotO, arrow.yRot, partialTick) - 90F));
+        GLRenderer.modelM4f().rotateZ(Math.toRadians(Math.lerp(arrow.xRotO, arrow.xRot, partialTick)));
 
         int arrowType = arrow.getArrowType();
 
         float bodyMinU = 0F / 32F;
         float bodyMaxU = 16F / 32F;
-        float bodyMinV = (float)(arrowType * 10) / 32F;
-        float bodyMaxV = (float)(5 + arrowType * 10) / 32F;
+        float bodyMinV = (float) (arrowType * 10) / 32F;
+        float bodyMaxV = (float) (5 + arrowType * 10) / 32F;
         float tailMinU = 0F / 32F;
         float tailMaxU = 5F / 32F;
-        float tailMinV = (float)(5 + arrowType * 10) / 32F;
-        float tailMaxV = (float)(10 + arrowType * 10) / 32F;
+        float tailMinV = (float) (5 + arrowType * 10) / 32F;
+        float tailMaxV = (float) (10 + arrowType * 10) / 32F;
         float scale = 9F / 160F;
 
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        float shakeAmount = (float)arrow.shake - partialTick;
-        if(shakeAmount > 0.0F)
-        {
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        float shakeAmount = (float) arrow.shake - partialTick;
+        if (shakeAmount > 0.0F) {
             float shakeAngle = -MathHelper.sin(shakeAmount * 3F) * shakeAmount;
-            GL11.glRotatef(shakeAngle, 0.0F, 0.0F, 1.0F);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(shakeAngle));
         }
 
         // Set up arrow transformation
-        GL11.glRotatef(45F, 1.0F, 0.0F, 0.0F);
-        GL11.glScalef(scale, scale, scale);
-        GL11.glTranslatef(-4F, 0.0F, 0.0F);
-        GL11.glNormal3f(scale, 0.0F, 0.0F);
+        GLRenderer.modelM4f().rotateX(Math.toRadians(45f));
+        GLRenderer.modelM4f().scale(scale, scale, scale);
+        GLRenderer.modelM4f().translate(-4F, 0.0F, 0.0F);
+//        GL11.glNormal3f(scale, 0.0F, 0.0F);
 
         // Draw arrow tail
         tessellator.startDrawingQuads();
@@ -51,7 +50,7 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow>
         tessellator.addVertexWithUV(-7D, 2D, 2D, tailMaxU, tailMaxV);
         tessellator.addVertexWithUV(-7D, 2D, -2D, tailMinU, tailMaxV);
         tessellator.draw();
-        GL11.glNormal3f(-scale, 0.0F, 0.0F);
+//        GL11.glNormal3f(-scale, 0.0F, 0.0F);
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(-7D, 2D, -2D, tailMinU, tailMinV);
         tessellator.addVertexWithUV(-7D, 2D, 2D, tailMaxU, tailMinV);
@@ -60,10 +59,9 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow>
         tessellator.draw();
 
         // Draw arrow body
-        for(int i = 0; i < 4; i++)
-        {
-            GL11.glRotatef(90F, 1.0F, 0.0F, 0.0F);
-            GL11.glNormal3f(0.0F, 0.0F, scale);
+        for (int i = 0; i < 4; i++) {
+            GLRenderer.modelM4f().rotateX(Math.PI_OVER_2_f);
+//            GL11.glNormal3f(0.0F, 0.0F, scale);
             tessellator.startDrawingQuads();
             tessellator.addVertexWithUV(-8D, -2D, 0.0D, bodyMinU, bodyMinV);
             tessellator.addVertexWithUV(8D, -2D, 0.0D, bodyMaxU, bodyMinV);
@@ -72,7 +70,7 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow>
             tessellator.draw();
         }
 
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-        GL11.glPopMatrix();
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
index b7349c67c..06c83cbdc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
@@ -2,8 +2,9 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.tileentity.TileEntityRendererFlag;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.vehicle.EntityBoat;
@@ -11,11 +12,9 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.wind.WindProvider;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 
-public class EntityRendererBoat extends EntityRenderer<EntityBoat>
-{
+public class EntityRendererBoat extends EntityRenderer<EntityBoat> {
 
     private final TileEntityRendererFlag flagRenderer;
     private final Minecraft mc = Minecraft.getMinecraft();
@@ -26,25 +25,21 @@ public class EntityRendererBoat extends EntityRenderer<EntityBoat>
     }
 
     @Override
-    public void render(@NotNull final Tessellator tessellator, @NotNull final EntityBoat entity, final double x, final double y, final double z,
-                       final float yaw, final float partialTick)
-    {
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float)x, (float)y, (float)z);
-        GL11.glRotatef(180F - yaw, 0.0F, 1.0F, 0.0F);
-        final float hurt = (float)entity.boatTimeSinceHit - partialTick;
-        float dmg = (float)entity.boatCurrentDamage - partialTick;
-        if(dmg < 0.0F)
-        {
+    public void render(@NotNull final TessellatorGeneral tessellator, @NotNull final EntityBoat entity, final double x, final double y, final double z,
+                       final float yaw, final float partialTick) {
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(180F - yaw));
+        final float hurt = (float) entity.boatTimeSinceHit - partialTick;
+        float dmg = (float) entity.boatCurrentDamage - partialTick;
+        if (dmg < 0.0F) {
             dmg = 0.0F;
         }
-        if(hurt > 0.0F)
-        {
-            GL11.glRotatef(((MathHelper.sin(hurt) * hurt * dmg) / 10F) * (float)entity.boatRockDirection, 1.0F, 0.0F, 0.0F);
+        if (hurt > 0.0F) {
+            GLRenderer.modelM4f().rotateX(Math.toRadians(((MathHelper.sin(hurt) * hurt * dmg) / 10F) * (float) entity.boatRockDirection));
         }
-        if (entity.tileEntityFlag != null)
-        {
+        if (entity.tileEntityFlag != null) {
             final World theWorld = this.mc.currentWorld;
             final WindProvider theWind = theWorld.getWorldType().getWindManager();
 
@@ -54,19 +49,19 @@ public class EntityRendererBoat extends EntityRenderer<EntityBoat>
             // If boat speed is 0, windAngle is 100% and boatAngle is 0%
             // If boat speed is > 3, windAngle is 0% and boatAngle is 100%
             final float boatSpeed = MathHelper.sqrt_float((float) (entity.xd * entity.xd + entity.zd * entity.zd));
-            final float angle = MathHelper.lerp(windAngle, boatAngle, (float)MathHelper.clamp(boatSpeed, 0, 0.25) * 4);
+            final float angle = MathHelper.lerp(windAngle, boatAngle, (float) MathHelper.clamp(boatSpeed, 0, 0.25) * 4);
 
             this.flagRenderer.doRender(tessellator, entity.tileEntityFlag, -1.19, 0.187, -0.5, partialTick, false, angle, 1.0f);
         }
-        TextureRegistry.blockAtlas.bind();
+        TextureRegistry.worldAtlas.bind();
         final float f4 = 0.75F;
-        GL11.glScalef(f4, f4, f4);
-        GL11.glScalef(1.0F / f4, 1.0F / f4, 1.0F / f4);
+        GLRenderer.modelM4f().scale(f4, f4, f4);
+        GLRenderer.modelM4f().scale(1.0F / f4, 1.0F / f4, 1.0F / f4);
         bindTexture("/assets/minecraft/textures/entity/boat.png");
-        GL11.glScalef(1/16f, 1/16f, -1/16f);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        getModel("main").render(tessellator);
-        GL11.glPopMatrix();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.modelM4f().scale(1 / 16f, 1 / 16f, -1 / 16f);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        getModel("main").render();
+        GLRenderer.popFrame();
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
index 4210664ab..bb218c880 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
@@ -1,25 +1,25 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.projectile.ProjectileCannonball;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
+import org.joml.Math;
 
-public class EntityRendererCannonball extends EntityRenderer<ProjectileCannonball>
-{
+public class EntityRendererCannonball extends EntityRenderer<ProjectileCannonball> {
 
     public EntityRendererCannonball() {
         super();
     }
 
     @Override
-    public void render(@NotNull final Tessellator tessellator, @NotNull final ProjectileCannonball entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float)x, (float)y, (float)z);
-        GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
+    public void render(@NotNull final TessellatorGeneral tessellator, @NotNull final ProjectileCannonball entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
         bindTexture("/assets/minecraft/textures/entity/cannonball.png");
-        GL11.glScalef(1/MobRenderer.ENTITY_RENDER_SCALE, 1/MobRenderer.ENTITY_RENDER_SCALE, -1/MobRenderer.ENTITY_RENDER_SCALE);
-        getModel("main").render(tessellator);
-        GL11.glPopMatrix();
+        GLRenderer.modelM4f().scale(1 / MobRenderer.ENTITY_RENDER_SCALE, 1 / MobRenderer.ENTITY_RENDER_SCALE, -1 / MobRenderer.ENTITY_RENDER_SCALE);
+        getModel("main").render();
+        GLRenderer.popFrame();
     }
 }
\ No newline at end of file
